#pragma once

#include <memory>

#include "Image.h"

class FontGlyph
{

public:
    FontGlyph(unsigned width, unsigned height, unsigned bearingX, unsigned bearingY,
            unsigned advanceX, std::unique_ptr<Image<unsigned char> > image);

    Image<unsigned char>* getImage() const;

    unsigned getWidth() const;
    unsigned getHeight() const;
    unsigned getBearingX() const;
    unsigned getBearingY() const;
    unsigned getAdvanceX() const;

private:
    unsigned mWidth{0};
    unsigned mHeight{0};
    unsigned mBearingX{0};
    unsigned mBearingY{0};
    unsigned mAdvanceX{0};
    std::unique_ptr<Image<unsigned char> > mImage;
};
