#include "TriFace.h"

#include "Edge.h"

TriFace::TriFace(Edge* edge0, Edge* edge1, Edge* edge2, unsigned id)
    : mEdge0(edge0),
      mEdge1(edge1),
      mEdge2(edge2),
      mId(id)
{

}

std::unique_ptr<TriFace> TriFace::Create(Edge* edge0, Edge* edge1, Edge* edge2, unsigned id)
{
    return std::make_unique<TriFace>(edge0, edge1, edge2, id);
}

TriFace::~TriFace()
{

}

std::vector<unsigned> TriFace::getNodeIds() const
{
    return {mEdge0->getNode0Id(), mEdge0->getNode1Id(), mEdge1->getNode1Id()};
}

void TriFace::addVectorAttribute(const std::string& tag, const std::vector<double>& values)
{
    mVectorAttributes[tag] = values;
}

std::vector<double> TriFace::getVectorAttribute(const std::string& tag) const
{
    auto iter = mVectorAttributes.find(tag);
    if (iter != mVectorAttributes.end())
    {
        return iter->second;
    }
    return {};
}
