#pragma once
#include <memory>

class GeometryNode;
class TextNode;

class VisualLayer
{
public:

    VisualLayer();

    static std::unique_ptr<VisualLayer> Create();

    GeometryNode* getShapeNode() const;
    TextNode* getTextNode() const;
    bool hasShapeNode() const;
    bool hasTextNode() const;
    void setShapeNode(std::unique_ptr<GeometryNode> shape);
    void setTextNode(std::unique_ptr<TextNode> text);

    bool getIsDirty() const
    {
        return mIsDirty;
    }

    void setIsDirty(bool isDirty)
    {
        mIsDirty = isDirty;
    }

private:
    bool mIsDirty{true};
    std::unique_ptr<GeometryNode> mShape;
    std::unique_ptr<TextNode> mText;
};
using VisualLayerUPtr = std::unique_ptr<VisualLayer>;
